import { J as Json, O as ObjectStorage, L as LogHandlerOptions, di as LogMessage, a as LogHandler, b as LogLevelAliasType, c as LoggerInterface } from './uuid-a75d0c48.js';
export { dT as ArgumentsType, cF as AsyncMutex, cZ as AsyncReturnType, a1 as BinInput, e as CRYPTO_DEFAULT_ALG, g as CRYPTO_DEFAULT_DERIVE_ALG, h as CRYPTO_DEFAULT_DERIVE_ITERATIONS, C as CRYPTO_DEFAULT_HASH_ALG, dt as Channel, ds as ChannelMessageEvent, dG as CryptoEncoder, aB as DAY_MS, a_ as Day, aD as DayInput, aZ as DayInputLegacy, aC as DayValue, b4 as DecimalInput, b3 as DecimalValue, dz as DefaultListener, d7 as DefaultLogger, cv as Disposable, cu as Disposer, ct as DisposerFunction, dA as Emitter, dx as EmitterAllHandler, dw as EmitterHandler, dD as Encoder, bx as FilterFunction, dF as JsonEncoder, dy as ListenerSignature, du as LocalChannel, d8 as LogLevel, dg as LogLevelAlias, dh as LogLevelAliasKey, d9 as LogLevelAll, da as LogLevelDebug, dd as LogLevelError, de as LogLevelFatal, db as LogLevelInfo, df as LogLevelOff, dc as LogLevelWarn, dl as LoggerConsoleHandler, dk as LoggerContext, dj as LoggerContextInterface, dr as LoggerMemoryHandler, by as MapperFunction, ec as MemStorage, eb as MemStorageOptions, dJ as Message, dH as MessageAction, dN as MessageDefinitions, dO as MessageHub, dI as MessageResult, dL as MessagesDefaultMethods, dM as MessagesMethods, dK as MessagesOptions, cE as Mutex, eg as NestedArray, dE as NoopEncoder, cJ as PoolConfig, cM as PoolTask, cN as PoolTaskEvents, cK as PoolTaskFn, cI as PoolTaskIdConflictResolution, cL as PoolTaskState, be as Primitive, cP as Progress, dR as PubSub, dW as RPCFn, dV as RPCOptions, dX as RPCReturn, ax as RenderMessagesOptions, dU as ReturnType, bX as RoundingMode, d0 as SerialQueue, c6 as SortableItem, c$ as TaskEvents, c_ as TaskFn, ah as Uint8ArrayToHexDump, ag as Uint8ArrayToJson, a5 as Uint8ArrayToString, cA as UseDefer, cx as UseDispose, cs as XRX, a3 as _decodeUtf8Polyfill, a2 as _encodeUtf8Polyfill, _ as _useBase, P as arrayAvg, Q as arrayBatches, A as arrayEmptyInPlace, y as arrayFilterInPlace, t as arrayFlatten, u as arrayIntersection, E as arrayIsEqual, K as arrayMax, M as arrayMin, q as arrayMinus, I as arrayRandomElement, w as arrayRemoveElement, x as arraySetElement, G as arrayShuffle, H as arrayShuffleForce, F as arrayShuffleInPlace, B as arraySorted, D as arraySortedNumbers, N as arraySum, v as arraySymmetricDifference, z as arrayToggleInPlace, s as arrayUnion, p as arrayUnique, d as assert, bK as avg, bI as between, cm as cloneJsonObject, cl as cloneObject, bT as cmp, bS as composeOrderby, R as createArray, dv as createLocalChannelPair, cQ as createPromise, dP as createPromiseProxy, n as csvParse, o as csvParseToObjects, m as csvStringify, b2 as dateStringToDays, b1 as day, aG as dayDay, aW as dayDiff, aK as dayFromAny, aM as dayFromDate, aN as dayFromDateGMT, aR as dayFromParts, aS as dayFromString, aP as dayFromTimestamp, aJ as dayFromToday, aY as dayIterator, aF as dayMonth, aT as dayMonthStart, aV as dayOffset, aX as dayRange, aI as dayToDate, aL as dayToDateGMT, aH as dayToParts, aQ as dayToString, aO as dayToTimestamp, aE as dayYear, aU as dayYearStart, d2 as debounce, b5 as decimal, b8 as decimalCentsPart, b6 as decimalFromCents, b7 as decimalToCents, W as decodeBase16, U as decodeBase32, Y as decodeBase58, $ as decodeBase62, l as decrypt, b9 as deepEqual, bb as deepMerge, ba as deepStripUndefinedInPlace, j as deriveKeyPbkdf2, e8 as detect, i as digest, ck as empty, V as encodeBase16, T as encodeBase32, X as encodeBase58, Z as encodeBase62, ce as encodeQuery, k as encrypt, c8 as endSortWeight, cg as ensureKey, ch as ensureKeyAsync, ae as equalBinary, bc as escapeHTML, bW as escapeRegExp, a0 as estimateSizeForBase, f as fatal, d$ as fetchBasic, e0 as fetchJson, e4 as fetchOptionsBasicAuth, e2 as fetchOptionsFormURLEncoded, e3 as fetchOptionsJson, e1 as fetchText, aA as fixBrokenUth8String, a$ as forEachDay, cp as forTimes, ay as formatMessages, ee as formatMilliseconds, ac as fromBase64, ad as fromBase64String, al as fromCamelCase, a9 as fromHex, e7 as getGlobal, d3 as getGlobalContext, dB as getGlobalEmitter, d5 as getGlobalLogger, d6 as getGlobalLoggerIfExists, dm as getNamespaceFilterString, e6 as getNavigator, bD as getSecureRandom, bE as getSecureRandomIfPossible, ed as getTimestamp, e5 as getWindow, dZ as httpMethod, cS as immediate, bh as isArray, bo as isBoolean, e9 as isBrowser, bZ as isEven, bY as isHalf, bm as isInteger, d4 as isLocalHost, bs as isNotNull, bq as isNull, bp as isNullOrUndefined, bl as isNumber, bf as isObject, bM as isPrime, bL as isPrimeRX, bg as isPrimitive, cX as isPromise, bi as isRecord, bj as isRecordPlain, bn as isSafeInteger, bk as isString, cU as isTimeout, br as isUint8Array, bt as isValue, a7 as joinToUint8Array, bw as jsonStringify, bv as jsonStringifySafe, bu as jsonStringifySorted, af as jsonToUint8Array, cj as last, dC as lazyListener, cc as linkifyPlainText, bB as listDistinctUnion, bA as listGroupBy, bC as listOfKey, bz as listQuery, cn as memoize, co as memoizeAsync, c9 as moveSortWeight, eh as noop, bQ as objectIsEmpty, bO as objectMap, bP as objectMergeDisposable, d_ as parseBasicAuth, ef as parseDate, dp as parseLogLevel, bR as parseOrderby, cf as parseQuery, cY as promisify, eD as qid, bF as randomBoolean, bH as randomFloat, bG as randomInt, r as randomUint8Array, cr as regExpEscape, cq as regExpString, az as renderMessages, b$ as roundDown, c2 as roundHalfAwayFromZero, c3 as roundHalfDown, c4 as roundHalfEven, c1 as roundHalfOdd, c5 as roundHalfTowardsZero, c0 as roundHalfUp, b_ as roundUp, bN as seededRandom, ex as setUuidDefaultEncoding, ci as size, cR as sleep, ca as sortedItems, bU as sortedOrderby, c7 as startSortWeight, am as stringToBoolean, ao as stringToFloat, an as stringToInteger, a4 as stringToUInt8Array, et as suid, es as suidBytes, ev as suidBytesDate, eu as suidDate, bJ as sum, d1 as throttle, cT as timeout, aa as toBase64, ab as toBase64Url, aw as toBool, ai as toCamelCase, aj as toCapitalize, ak as toCapitalizeWords, at as toFloat, a8 as toHex, cd as toHumanReadableUrl, au as toInt, av as toString, a6 as toUint8Array, bV as toValidFilename, b0 as today, cV as tryTimeout, eC as uname, bd as unescapeHTML, cH as useAsyncMutex, S as useBase, cz as useDefer, cw as useDispose, cy as useDisposer, cD as useEventListener, ea as useExitHandler, cC as useInterval, dq as useLevelFilter, dQ as useMessageHub, cG as useMutex, dn as useNamespaceFilter, cO as usePool, dS as usePubSub, dY as useRPC, cb as useSorted, cB as useTimeout, ey as uuid, ew as uuid32bit, em as uuidB32, ej as uuidB62, ei as uuidBytes, ez as uuidDecode, eo as uuidDecodeB32, el as uuidDecodeB62, er as uuidDecodeV4, eA as uuidEncode, en as uuidEncodeB32, ek as uuidEncodeB62, eq as uuidEncodeV4, eB as uuidIsValid, ep as uuidv4, ap as valueToBoolean, ar as valueToFloat, aq as valueToInteger, as as valueToString, cW as waitOn } from './uuid-a75d0c48.js';

interface ParseConfig {
    args?: string[];
    alias?: Record<string, string[]>;
    normalize?: (value: string) => string;
    booleanArgs?: string | string[];
    listArgs?: string | string[];
    numberArgs?: string | string[];
}
declare function parseArgs(config?: ParseConfig): Record<string, any>;

/** Copy string to clipboard */
declare function pbcopy(data: string): Promise<unknown>;

declare function setupWebCrypto(): void;
declare function getWebCrypto(): Promise<Crypto>;

interface csvOptions {
    /** @deprecated will probably be replaced by logLevel */
    debug?: boolean;
    path?: string;
    filename?: string;
    encoding?: BufferEncoding;
    prefix?: string;
    env?: Record<string, string>;
}
/**
 * Return a path relative to the current working directory
 */
declare function stringToPath(value?: string, defaultValue?: string): string;
declare function valueToPath(value?: any, defaultValue?: string): string;
declare const toPath: typeof valueToPath;
declare function getEnvVariableRelaxed(name: string, env?: NodeJS.ProcessEnv): string | undefined;
/** Populates process.env from .env file. */
declare function setupEnv(options?: csvOptions): {
    parsed: Record<string, string>;
    error?: undefined;
} | {
    error: unknown;
    parsed?: undefined;
};

interface FileStorageOptions {
    pretty?: boolean;
    path?: string;
    extension?: string;
    objectFromString?: (data: string) => any;
    objectToString?: (data: any) => string;
    keyToFilename?: (key: string) => string;
}
declare class FileStorage<T = Json> implements ObjectStorage<T> {
    private store;
    private dirname;
    private fileKeys?;
    private pretty;
    private extension;
    private extensionLength;
    private objectFromString;
    private objectToString;
    private keyToFilename;
    constructor(opt?: FileStorageOptions);
    setItem(key: string, value: T): void;
    getPath(key: string): string;
    getBuffer(key: string): Buffer;
    getItem(key: string): T | undefined;
    removeItem(key: string): void;
    clear(): void;
    allKeys(): string[];
}

declare function toHumanReadableFilePath(path: string): string;
declare function exists(path: string): Promise<boolean>;
declare function ensureFolder(...parts: string[]): Promise<string>;
declare function removeFolder(...parts: string[]): Promise<string>;
declare function readText(...parts: string[]): Promise<string | undefined>;
declare function writeText(path: string, content: string): Promise<void>;

declare function LoggerFileHandler(path: string, opt?: LogHandlerOptions): (msg: LogMessage) => void;

declare function colorString(text: string, colorCode: number): string;
declare function colorStringList(list: Array<any>, style: string, bold?: boolean): any[];
declare const loggerStackTraceDebug = "loggerStackTraceDebug-7d38e5a9214b58d29734374cdb9521fd964d7485";
declare function LoggerNodeHandler(opt?: LogHandlerOptions): LogHandler;

declare function getStackLlocationList(stack: string): string[];
/**
 * Get the source code location of the caller
 * https://stackoverflow.com/a/47296370/140927
 *
 * @param level Number of levels to go down the stack trace
 * @param stripCwd Strip the current working directory, only reasonable for Node.js environment
 * @returns
 */
declare function getSourceLocation(level?: number, stripCwd?: boolean): string;
declare function getStack(): string;
declare function getSourceLocationByPrecedingPattern(patterns: string[], stripCwd?: boolean): string;

declare function Logger(name?: string, level?: LogLevelAliasType): LoggerInterface;

export { FileStorage, FileStorageOptions, Json, LogHandler, LogHandlerOptions, LogLevelAliasType, LogMessage, Logger, LoggerFileHandler, LoggerInterface, LoggerNodeHandler, ObjectStorage, colorString, colorStringList, ensureFolder, exists, getEnvVariableRelaxed, getSourceLocation, getSourceLocationByPrecedingPattern, getStack, getStackLlocationList, getWebCrypto, loggerStackTraceDebug, parseArgs, pbcopy, readText, removeFolder, setupEnv, setupWebCrypto, stringToPath, toHumanReadableFilePath, toPath, valueToPath, writeText };
